Subject: bug#5208 closed by [email-masked] (Nick Roberts) (bug#5208: 23.1.90; M-x gud-gdb: Tab Completion Produces Spurious Ctrl-M Characters)

From: [email-masked] (Emacs bug Tracking System)
Date: Mon, 14 Dec 2009 06:35:11 +0000

This is an automatic notification regarding your bug report
which was filed against the emacs package:

#5208: 23.1.90; M-x gud-gdb: Tab Completion Produces Spurious Ctrl-M Characters

It has been closed by [email-masked] (Nick Roberts).

Their explanation is attached below along with your original report.
If this explanation is unsatisfactory and you have not received a
better one in a separate message then please contact [email-masked] (Nick Roberts) by
replying to this email.

-- 
5208: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=5208
Emacs Bug Tracking System
Contact [email-masked] with problems

Subject: bug#5208: 23.1.90; M-x gud-gdb: Tab Completion Produces Spurious Ctrl-M Characters
From: [email-masked] (Nick Roberts)
To: Steve Revilak <[email-masked]>, [email-masked]
Cc: [email-masked]
Date: Mon, 14 Dec 2009 19:30:46 +1300

 > gdb is
 > 
 >    $ gdb --version
 >    GNU gdb 6.3.50-20050815 (Apple version gdb-768) (Tue Oct  2 04:07:49 UTC 2007)
 >    Copyright 2004 Free Software Foundation, Inc.
 >    GDB is free software, covered by the GNU General Public License, and you are
 >    welcome to change it and/or distribute copies of it under certain conditions.
 >    Type "show copying" to see the conditions.
 >    There is absolutely no warranty for GDB.  Type "show warranty" for details.
 >    This GDB was configured as "i386-apple-darwin".
 > 
 > The operating system is Mac OS X 10.5.8

I think the spurious Ctrl-M characters appeared with Leopard and weren't
present in Tiger but, in any case Apple GDB has it's own behaviours tailored
for their Xcode application.  For best results, and no ^M characters, download
the latest (7.0) FSF gdb (http://sourceware.org/gdb/download/) or checkout
from the CVS repository (http://sourceware.org/gdb/current/) which both build on
Darwin.

I have closed this report since FSF gdb fixes this problem and support of Apple gdb
probably isn't an FSF priority.

-- 
Nick                                           http://users.snap.net.nz/~nickrob

Subject: 23.1.90; M-x gud-gdb: Tab Completion Produces Spurious Ctrl-M Characters
From: Steve Revilak <[email-masked]>
To: [email-masked]
Date: Sun, 13 Dec 2009 10:47:38 -0500

Please write in English if possible, because the Emacs maintainers
usually do not have translators to read other languages for them.

Your bug report will be posted to the [email-masked] mailing list.

Please describe exactly what actions triggered the bug
and the precise symptoms of the bug.  If you can, give
a recipe starting from `emacs -Q':

                                 * * *

In Emacs 23.1.90.1, tab completion in M-x gud-gdb produces spurious
control-M characters; it almost appears as if Ctrl-M is being appended
to each symbol name offered for completion.

Below, I will give steps to reproduce this behavior, and the results
that I observe when following these steps.  For this example, any time
that you see "^M" (consisting of two characters -- "^" and "M"),
please interpret this as the visual representation of the single
character Ctrl-M (0x0d).

First we will need a C program to debug.  I will use the following
program:

---------- begin demo2.c --------------
#include <stdio.h>

static void add_one(int * x) {
   *x += 1;
}

static void add_two (int * x) {
   *x += 2;
}

int main(void) {
   int val = 0;
   add_one(&val);
   add_two(&val);
   printf("val=%d\n", val);
   return 0;
}
---------- end demo2.c   --------------

STEPS TO REPRODUCE
------------------

(1) Compile demo2.c.
     gcc -g -o demo2 demo2.c

(2) start emacs.
     emacs -Q -nw demo2.c

(3) start the debugger
     M-x gud-gdb RET

     Emacs offers the following:
     "Run gud-gdb (like this): gdb --fullname demo2"

     Press RETURN to accept the gdb command line.

(4) Emacs starts the debugger in buffer "*gud-demo2*", and displays
     the "(gdb)" prompt.

     At the gdb prompt enter the commands

       - b main RETURN
       - run RETURN

(5) Emacs begins to run demo2 under gdb, and breaks in the first line
     of main.

(6) I'd like to set a breakpoint in function "add_one".  At the (gdb)
     prompt in the *gud-demo* buffer, I type "b add TAB".

     After I press TAB, emacs displays a *Completions* buffer with the
     following:
---------------------------------
In this buffer, type RET to select the completion near point.

Possible completions are:
add_fdes^M                add_one^M                 add_profil^M
add_two^M                 addcmd^M                  addr2ascii^M
---------------------------------

     Note that every symbol is suffixed with "^M"

(7) At the (gdb) prompt in the "*gud-demo*" buffer, I type the
     characters "_o", so that the current (gdb) prompt line contains
     "b add_o".  I press TAB to complete the function name.

     *gud-demo* completes the function name, and displays
---------------------------------
(gdb) b add_one^M
---------------------------------

     Note that a "^M" was appended to the completed symbol name.

(8) At the (gdb) prompt, I type RETURN to create the breakpoint.
     Emacs responds with
---------------------------------
Breakpoint 2 at 0x1f88: file demo2.c, line 4.
(gdb) (gdb)
---------------------------------

     Note that *gud-demo* displays two (gdb) prompts after I press RETURN.

(9) At the (gdb) prompt, I type "c RETURN" to continue running demo2.

(10) After reaching the breakpoint in add_one, I type "c RETURN" to
      continue again.  demo2 continues executing and exits.

After demo2 exits, the *gud-demo2* buffer contains the following
contents:

---------------------------------
Current directory is ~/
GNU gdb 6.3.50-20050815 (Apple version gdb-768) (Tue Oct  2 04:07:49 UTC 2007)
Copyright 2004 Free Software Foundation, Inc.
GDB is free software, covered by the GNU General Public License, and you are
welcome to change it and/or distribute copies of it under certain conditions.
Type "show copying" to see the conditions.
There is absolutely no warranty for GDB.  Type "show warranty" for details.
This GDB was configured as "i386-apple-darwin"...Reading symbols for shared libraries ... done

(gdb) b main
Breakpoint 1 at 0x1fb9: file demo2.c, line 12.
(gdb) run
Starting program: /Users/srevilak/demo2
Reading symbols for shared libraries ++. done

Breakpoint 1, main () at demo2.c:12
(gdb) b add_one^M
Breakpoint 2 at 0x1f88: file demo2.c, line 4.
(gdb) (gdb) c
Continuing.

Breakpoint 2, add_one (x=0xbffff16c) at demo2.c:4
(gdb) c
Continuing.
val=3

Program exited normally.
(gdb)
---------------------------------

HOW THIS DIFFERS FROM EXPECTED BEHAVIOR
---------------------------------------

  * I did not expect to see ^M appended to each symbol name in the
    *completions* buffer (step 6).

  * I did not expect to see ^M appended to the completed symbol name
    (step 7).

  * I did not expect to see the extra (gdb) prompt in step 8.

NOTES:
-----

For this report, gcc is

   $ gcc --version
   i686-apple-darwin9-gcc-4.0.1 (GCC) 4.0.1 (Apple Inc. build 5465)
   Copyright (C) 2005 Free Software Foundation, Inc.
   This is free software; see the source for copying conditions.  There is NO
   warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

gdb is

   $ gdb --version
   GNU gdb 6.3.50-20050815 (Apple version gdb-768) (Tue Oct  2 04:07:49 UTC 2007)
   Copyright 2004 Free Software Foundation, Inc.
   GDB is free software, covered by the GNU General Public License, and you are
   welcome to change it and/or distribute copies of it under certain conditions.
   Type "show copying" to see the conditions.
   There is absolutely no warranty for GDB.  Type "show warranty" for details.
   This GDB was configured as "i386-apple-darwin".

The operating system is Mac OS X 10.5.8

   $ uname -a
   Darwin oatmeal.local 9.8.0 Darwin Kernel Version 9.8.0: Wed Jul 15 16:55:01 PDT 2009; root:xnu-1228.15.4~1/RELEASE_I386 i386

The same behavior occurs with

    GNU Emacs 23.1.90.1 (powerpc-apple-darwin8.11.0, NS apple-appkit-824.48)
    on Mac OS X 10.4.11

                                 * * *

If Emacs crashed, and you have the Emacs process in the gdb debugger,
please include the output from the following gdb commands:
     `bt full' and `xbacktrace'.
For information about debugging Emacs, please read the file
/Applications/Emacs.app/Contents/Resources/etc/DEBUG.

In GNU Emacs 23.1.90.1 (i386-apple-darwin9.8.0, NS apple-appkit-949.54)
  of 2009-12-09 on oatmeal.ma.runwaynine.com
Windowing system distributor `Apple', version 10.3.949
configured using `configure  '--with-ns''

Important settings:
   value of $LC_ALL: nil
   value of $LC_COLLATE: C
   value of $LC_CTYPE: nil
   value of $LC_MESSAGES: nil
   value of $LC_MONETARY: nil
   value of $LC_NUMERIC: nil
   value of $LC_TIME: nil
   value of $LANG: nil
   value of $XMODIFIERS: nil
   locale-coding-system: nil
   default enable-multibyte-characters: t

Major mode: Lisp Interaction

Minor modes in effect:
   tooltip-mode: t
   mouse-wheel-mode: t
   tool-bar-mode: t
   menu-bar-mode: t
   file-name-shadow-mode: t
   global-font-lock-mode: t
   font-lock-mode: t
   global-auto-composition-mode: t
   auto-composition-mode: t
   auto-encryption-mode: t
   auto-compression-mode: t
   line-number-mode: t
   transient-mark-mode: t

Recent input:
ESC x r e p o r t - e m TAB RET

Recent messages:
("/Applications/Emacs.app/Contents/MacOS/Emacs")
For information about GNU Emacs and the GNU system, type C-h C-a.

Load-path shadows:
None found.

Features:
(shadow mail-extr message ecomplete rfc822 mml mml-sec password-cache
mm-decode mm-bodies mm-encode mailcap mail-parse rfc2231 rfc2047 rfc2045
qp ietf-drums mailabbrev nnheader gnus-util netrc time-date mm-util
mail-prsvr gmm-utils wid-edit mailheader canlock sha1 hex-util hashcash
mail-utils warnings emacsbug sendmail regexp-opt tooltip ediff-hook
vc-hooks lisp-float-type mwheel ns-win easymenu tool-bar dnd fontset
image fringe lisp-mode register page menu-bar rfn-eshadow timer select
scroll-bar mldrag mouse jit-lock font-lock syntax facemenu font-core
frame cham georgian utf-8-lang misc-lang vietnamese tibetan thai
tai-viet lao korean japanese hebrew greek romanian slovak czech european
ethiopic indian cyrillic chinese case-table epa-hook jka-cmpr-hook help
simple abbrev loaddefs button minibuffer faces cus-face text-properties
overlay md5 base64 format env code-pages mule custom widget
hashtable-print-readable backquote make-network-process ns multi-tty
emacs)